function bCharaFunctions(sprite)
{
	this.Spriteset = sprite;
	this.width  = this.Spriteset.images[this.Spriteset.directions[0].frames[0].index].width;
	this.height = this.Spriteset.images[this.Spriteset.directions[0].frames[0].index].height;
	this.currentX = 0;
	this.currentY = 0;
	this.x = 0;
	this.y = 0;
	this.MoveStart = 0;
	this.MoveX = 0;
	this.MoveY = 0;
	this.Moving = false;
	this.AnimFrame = 0;
	this.AnimDelay = 0;
	this.Facing = "east";
	this.Dying = false;
	this.DyingMask = CreateColor(255, 255, 255);
	this.DyingStage = "w";
	this.DyingC = 0;
	this.DyingTime = 0;
	this.levitating = false;
	this.levitateY = 0;
	this.preLevitate = 0;
	this.levitateTime = 0;
	this.movingTime = 0;
	this.imgSFX = LoadSpriteset("blank.rss");
	this._FindSpritesetDirection = function(spriteset, direction)
	{
		for (var i = 0; i < spriteset.directions.length; i++)
		{
			if (spriteset.directions[i].name == direction)
				return spriteset.directions[i];
		}
		return false;
	};
	this.Direction = this._FindSpritesetDirection(this.Spriteset, "east");
	this.GetBaseX = function()
	{
		return this.currentX + (this.Spriteset.base.x1 + this.Spriteset.base.x2) / 2;
	};
	this.GetBaseY = function()
	{
		return this.currentY + (this.Spriteset.base.y1 + this.Spriteset.base.y2) / 2;
	};
	this.SetDirection = function(dir)
	{
		this.Direction = this._FindSpritesetDirection(this.Spriteset, dir);
		this.AnimFrame = 0;
	};
	this.Render = function()
	{
		if (this.Dying)
			this.Spriteset.images[this.Direction.frames[this.AnimFrame].index].blitMask(this.currentX, this.currentY, this.DyingMask);
		else
			this.Spriteset.images[this.Direction.frames[this.AnimFrame].index].blit(this.currentX, this.currentY);
	};
	this.MoveTo = function(x, y, frames)
	{
		this.MoveStart = GetTime();
		this.MoveX = (x - this.currentX) / frames;
		this.MoveY = (y - this.currentY) / frames;
		this.Moving = true;
		this.MovingTime = GetTime();
		this.MoveFrames = frames;
		this.MoveFrameI = 0;
		this.x = this.currentX;
		this.y = this.currentY;
	};
	this.AnimatePose = function(pose)
	{
		this.AnimateDirection(this.Facing + "-" + pose);
	};
	this.TakeDamage = function(damage)
	{
		this.HP -= damage;
		this.Check();
	};
	this.PlayDeadAnim = function()
	{
		this.Dying = true;
		this.DyingMask = CreateColor(255, 255, 255);
		this.DyingStage = "w";
		this.DyingC = 0;
		this.DyingTime = GetTime();
	};
	this.AnimateDirection = function(dir)
	{
		var o = this.Direction.name;
		this.SetDirection(dir);
		var sdirection = this.Direction;
		for (var i = 0; i < sdirection.frames.length; i++)
		{
			this.AnimFrame = i;
		}
		this.SetDirection(o);
	};
	this.Update = function()
	{
		if (this.Dying)
		{
			if (this.DyingStage == "w")
			{
				this.DyingC = GetTime()-this.DyingTime;
				if (this.DyingC >= 500)
				{
					this.DyingStage = "r";
					this.DyingC = 0;
					this.DyingTime = GetTime();
				}
			}
			else if (this.DyingStage == "r")
			{
				this.DyingC = (GetTime()-this.DyingTime)/750*255;
				if (this.DyingC >= 255)
				{
					this.DyingStage = "f";
					this.DyingC = 255;
					this.DyingTime = GetTime();
					this.DyingMask.blue = 0;
					this.DyingMask.green = 0;
				}
				else
				{
					this.DyingMask.blue = 255 - this.DyingC;
					this.DyingMask.green = 255 - this.DyingC;
				}
			}
			else
			{
				this.DyingC = (GetTime()-this.DyingTime)/1000*255;
				if (this.DyingC >= 255)
				{
					this.DyingMask.alpha = 0;
				}
				else
				{
					this.DyingMask.alpha = 255 - this.DyingC;
				}
			}
		}
		if (this.levitating)
		{
			this.currentY = this.preLevitate + 5 * Sin(this.levitateY);
			this.levitateY = (GetTime()-this.levitateTime)/1500*Pi;
			if(this.levitateY > Pi)
				this.levitateTime = GetTime();
		}
		if (this.Moving)
		{
			this.currentX += (GetTime()-this.movingTime) / this.MoveX;
			this.currentY += this.MoveY;
			this.MoveFrameI++;
			if (this.MoveFrameI == this.MoveFrames)
			{
				this.Moving = false;
			}
		}
	};
	this.Levitate = function()
	{
		this.preLevitate = this.currentY;
		this.levitating = true;
		this.levitateTime = GetTime();
	};
	this.SFX = function(sfximage)
	{
		this.imgSFX = LoadSpriteset(sfximage);
	}
}