RequireScript("Data.js");
RequireScript("Monster.js");

function battleFlipScreen()
{
	var lastFlip=GetTime()+100/6;
	while(GetTime()<lastFlip){}
	FlipScreen();
}

function random(num1,num2)
{
	var num=Floor(Random()*(num2-num1+1))+num1;
	return num;
}

function scriptBattle(type, allowedToRun)
{
	var canRun = (allowedToRun) ? false : true;
	var battle = new newBattle(type, canRun);
	battle.doBattle();
}

function touchBattle(type, allowedToRun)
{
	m=GetCurrentPerson();
	SetPersonScript(m,SCRIPT_ON_ACTIVATE_TOUCH,"");
	SetPersonScript(m,SCRIPT_COMMAND_GENERATOR,"");
	var canRun = (allowedToRun) ? false : true;
	var battle = new newBattle(type, canRun);
	battle.doBattle();
	DestroyPerson(m);
}

function sortNumbers(a, b) { return b - a;}

function newBattle(type, allowedToRun)
{
	// INIT/LOAD/STORE
	this.canRun = allowedToRun;
	this.type = Data.Load("Battle/" + type + ".data");
	this.charas = [];
	this.enemies = [];
	this.orderOfTurn = [];
	this.help = "";
	this.msg = "";
	this.choosingAttacks = true;
	this.background = LoadImage(this.type.Background);
	this.chosen = 0;
	ws.drawWindow(4,4,312,15);
	ws.drawWindow(4,169,50,67);
	ws.drawWindow(62,169,254,67);
	this.windows = GrabSurface(0,0,320,240);
	this.windows.setBlendMode(REPLACE);
	var col = CreateColor(255,255,255,0);
	this.windows.rectangle(0,24,320,142,col);
	this.windows = this.windows.createImage();
	for(var i=0;i<Char.length;i++)
	{
		if(Char[i].party)
			this.charas.push(Char[i]);
	}
	for(var i=0;i<this.charas.length;i++)
	{
		this.charas[i].functions.currentX = 290-this.charas[i].functions.GetBaseX();
		this.charas[i].functions.currentY = 30+i*35;
		this.orderOfTurn.push(this.charas[i].Stats.Speed);
	}
	for(var i=0;i<this.type.Monsters.length;i++)
	{
		this.enemies.push(new createMonster(Data.Load("Monsters/" + this.type.Monsters[i].Data + ".data")));
	}
	for(var i=0;i<this.enemies.length;i++)
	{
		this.enemies[i].name = this.type.Monsters[i].Name;
		this.enemies[i].functions.currentX = this.type.Monsters[i].x;
		this.enemies[i].functions.currentY = this.type.Monsters[i].y;
		this.orderOfTurn.push(this.enemies[i].Stats.Speed);
	}
	// SORT ALL OBJECTS BY THEIR SPEED STAT.
	this.orderOfTurn.sort(sortNumbers);
}

newBattle.prototype.doBattle = function()
{
	this.transitionIn();
	this.done=false;
	this.won = false;
	var i = -1;
	var j = 0;
	while(!this.done)
	{
		i = -1;
		this.choosingAttacks = true;
		while (++i<this.charas.length)
		{
			this.chosen = i;
			// CHECK IF DEAD. IF NOT, CHOOSE ATTACKS!
			if (this.charas[i].Stats.HP>0)
			{
				this.attackMenu();
			}
			i = this.chosen;
		}//end player turn
		i = -1;
		while (++i<this.enemies.length)
		{
			// CHECK IF DEAD. IF NOT, RANDOM ATTACK!
			if (this.enemies[i].Stats.HP>0)
			{
				this.enemies[i].command[0] = "Attack";
				this.enemies[i].command[1] = random(0,this.charas.length-1);
			}
		}//end monster turn
		// attack phase. everybody deals damage now, according to speed.
		this.attackPhase();
	}//end while battle
	
	for(var i=0;i<this.charas.length;i++)
	{
		this.charas[i].functions.currentX = 0;
		this.charas[i].functions.currentY = 0;
	}
	
	var t2 = GetTime();
	while (GetTime()-t2<1000) {}
	font.drawText(6,6,"Battle over.");
	FlipScreen();
	t2 = GetTime();
	while (GetTime()-t2<1000) {}
}

newBattle.prototype.checkStatus = function()
{
	var charasDead = 0;
	var enemiesDead = 0;
	i = -1;
	while (++i<this.enemies.length)
	{
		if (this.enemies[i].Stats.HP<=0)
			enemiesDead++;
	}
	i = -1;
	while (++i<this.charas.length)
	{
		if (this.charas[i].Stats.HP<=0)
			charasDead++;
	}
	// CHECK HP.
	if(enemiesDead==this.enemies.length)
	{
		this.won = true;
		this.done = true;
	}
	else if(charasDead==this.charas.length)
		this.done = true;
}

newBattle.prototype.waitForZButton = function()
{
	var key;
	while (key!=KEY_Z)
	{
		key = PressKey();
		this.drawImages();
		FlipScreen();
	}
}

newBattle.prototype.goBackwards = function()
{
	var count=0;
	while(count<this.chosen)
	{
		if(this.charas[count].Stats.HP>0)
			this.chosen = count;
	}
}

//--------------------------------------------------------------------------------------------
//
//						ATTACK MENU
//
//--------------------------------------------------------------------------------------------

newBattle.prototype.attackMenu = function()
{
	var done=false;
	var maxChoices = (this.canRun) ? 4 : 3;
	var currentChoice=1;
	var key;
	var target;
	while(!done)
	{
		if(currentChoice==1)
			this.help = "Attack a monster.";
		else if(currentChoice==2)
			this.help = "Use techniques/spells";
		else
			this.help = "Run away from the current battle.";
		this.drawImages();
		arrow.blit(3,currentChoice*13+190-24);
		FlipScreen();
		
		key = PressKey();
		
		if(key==KEY_DOWN && currentChoice < maxChoices)
		{
			currentChoice++;
		}
		else if(key==KEY_UP && currentChoice > 1)
		{
			currentChoice--;
		}
		else if(key==KEY_Z)
		{
			if(currentChoice==1) // Attack
			{
				target = this.chooseTarget("enemy");
				if(target!=-1)
				{
					this.charas[this.chosen].command[0] = "Attack";
					this.charas[this.chosen].command[1] = target;
					done = true;
				}
			}
			else if(currentChoice==2) // Spell/Summon
			{
				// choose spell...
				
				
				//if the spell targets everyone (enemies or party, don't run choose targets
				var spellTargets = this.charas[0].Skills[0].targets;
				if(spellTargets == "allEnemies" || spellTargets == "party")
				{
					this.charas[this.chosen].command[0] = this.charas[0].Skills[0].name;
					this.charas[this.chosen].command[1] = spellTargets;
				}
				else
				{
					target = this.chooseTarget(spellTargets);
					if(target!=-1)
					{
						this.charas[this.chosen].command[0] = this.charas[0].Skills[0].name;
						this.charas[this.chosen].command[1] = target;
						done = true;
					}
				}
			}
			else if(currentChoice==3) // Item
			{
				//item menu
			}
			else // Run
			{
			}
		}
		else if(key==KEY_X)
		{
			this.goBackwards();
		}
	}
}

//--------------------------------------------------------------------------------------------
//
//						PICK A TARGET
//
//--------------------------------------------------------------------------------------------

newBattle.prototype.chooseTarget = function(targets)
{
	var key;
	var currentChoice=0;
	var trgt = (targets && targets !="") ? targets : "enemy";
	var players = (trgt == "enemy") ? this.enemies : this.charas;
	
	while(players[currentChoice].Stats.HP<=0)
	{
		currentChoice++;
	}
	while(true)
	{
		this.help = "Choose " + players[currentChoice].name + "?";
		this.drawImages();
		hand.blit(players[currentChoice].functions.GetBaseX()-32,players[currentChoice].functions.GetBaseY()-8);
		FlipScreen();
		
		key = PressKey();
		
		if(key==KEY_DOWN)
		{
			currentChoice++;
			if(currentChoice>players.length-1)
				currentChoice=0;
		}
		else if(key==KEY_UP)
		{
			currentChoice--;
			if(currentChoice<0)
				currentChoice=players.length-1;
		}
		else if(key==KEY_Z)
		{
			return currentChoice;
		}
		else if(key==KEY_X)
		{
			return -1;
		}
	}
	return -1;
}

//--------------------------------------------------------------------------------------------
//
//						ATTACK PHASE
//
//--------------------------------------------------------------------------------------------

newBattle.prototype.attackPhase = function()
{
	this.choosingAttacks = false;
	
	var attacker = new character();
	var defender = new character();
	//to ensure no repeats.
	var allArray = [];
	var count=-1;
	for(var i=0;i<this.charas.length;i++)
	{
		if(this.charas[i].Stats.HP > 0)
		{
			count++;
			allArray[count] = this.charas[i];
		}
	}
	for(var i=0;i<this.enemies.length;i++)
	{
		if(this.enemies[i].Stats.HP > 0)
		{
			count++;
			allArray[count] = this.enemies[i];
		}
	}
	
	this.orderOfTurn = new Array();
	
	for(var i=0;i<allArray.length;i++)
	{
		this.orderOfTurn.push(allArray[i].Stats.Speed*allArray[i].tempSpeed);
	}
	this.orderOfTurn.sort(sortNumbers);
	while(this.orderOfTurn.length>0 && !this.done)
	{
		for(var i=0;i<allArray.length;i++)
		{
			if(!allArray[i].party)
			{
				while(this.charas[allArray[i].command[1]].Stats.HP <= 0)
				{
					allArray[i].command[1] = random(0,this.charas.length-1);
				}
			}
			else
			{
				while(this.enemies[allArray[i].command[1]].Stats.HP <= 0)
				{
					allArray[i].command[1] = random(0,this.enemies.length-1);
				}
			}
			if(allArray[i].Stats.Speed*allArray[i].tempSpeed == this.orderOfTurn[0] && allArray[i].command[0] != "None" && !this.done)
			{
				attacker = allArray[i];
				if(allArray[i].party)
					defender = this.enemies[allArray[i].command[1]];
				else
					defender = this.charas[allArray[i].command[1]];
				this.damagePerson(attacker,defender);
				allArray[i].command[0] = "None";
				this.waitForZButton();
				this.msg="";
				this.checkStatus();
				this.orderOfTurn.shift();
			}
			if(this.done)
				break;
		}
	}
}

//--------------------------------------------------------------------------------------------
//
//						DEAL DAMAGE TO A PERSON
//
//--------------------------------------------------------------------------------------------

newBattle.prototype.damagePerson = function(attacker, defender)
{
	this.msg += attacker.name+" attacks "+defender.name+"!\n";
	// CHECK FOR EVASION. IF NOT, DEAL DAMAGE!
	if (random(0,100)>defender.Stats.Evasion)
	{
		var dmg = this.determineDamage(attacker, defender);
		this.msg += dmg+" damage!\n";
		defender.Stats.HP -= dmg;
		if(defender.Stats.HP <= 0)
		{
			defender.Stats.HP = 0;
			this.msg += defender.name+" died!\n";
			if(!defender.party)
				defender.functions.PlayDeadAnim();
			defender.Status.Dead = true;
		}
	}
	else
		this.msg += attacker.name+" missed!\n";
}

//--------------------------------------------------------------------------------------------
//
//						DETERMINE DAMAGE
//
//--------------------------------------------------------------------------------------------
newBattle.prototype.determineDamage = function(attacker, defender)
{
	var A = attacker.Stats.Attack;
	var L = attacker.Stats.Level;
	var tA = attacker.tempAttack;
	var D = defender.Stats.Defense;
	var D = defender.tempDefense;
	var R = random(85,100);
	return Floor(( R / 50 ) * ( ( ( A * tA ) / ( 50 * D ) ) * ( L / 5 + 1 ) + 1));
}

//--------------------------------------------------------------------------------------------
//
//						DRAW IMAGES AND HELP/BATTLE TEXT
//
//--------------------------------------------------------------------------------------------

newBattle.prototype.drawImages = function()
{
	this.background.blit(0,0);
	this.drawSprites();
	this.windows.blit(0,0);
	if(this.choosingAttacks)
		this.drawHelpText();
	else
		this.drawBattleText();
	
}

newBattle.prototype.drawHelpText = function()
{
	font.drawTextBox(6,6,320,14,0,this.help);
	for(var i=0;i<this.charas.length;i++)
	{
		if(this.chosen==i)
			font.setColorMask(yellowBattle);
		font.drawText(64,190+12*i-14,this.charas[i].name);
		font.setColorMask(white);
		font.drawText(161,190+12*i-14,this.charas[i].Stats.HP+"/"+this.charas[i].Stats.maxHP);
		font.drawText(237,190+12*i-14,this.charas[i].Stats.MP+"/"+this.charas[i].Stats.maxMP);
	}
	font.drawTextBox(10,177,38,52,0,"Attack\n"+this.charas[this.chosen].secondOption+"\nItem");
	if(!this.canRun)
		font.setColorMask(gray);
	font.drawTextBox(10,215,38,52,0,"Run");
	font.setColorMask(white);
}
newBattle.prototype.drawBattleText = function()
{
	talkImg.blit(0,165);
	font.drawTextBox(8,190-14,304,72,0,this.msg);
}

newBattle.prototype.drawSprites = function()
{
	this.drawParty();
	this.drawEnemies();
}

newBattle.prototype.drawParty = function()
{
	for(var i=0;i<this.charas.length;i++)
	{
		this.charas[i].functions.Update();
		this.charas[i].functions.Render();
		if(this.charas[i].Status.Dead)
			this.charas[i].functions.SetDirection("dead-west");
	}
}

newBattle.prototype.drawEnemies = function()
{
	for(var i=0;i<this.enemies.length;i++)
	{
		this.enemies[i].functions.AnimateDirection("east");
		this.enemies[i].functions.Update();
		this.enemies[i].functions.Render();
	}
}


//--------------------------------------------------------------------------------------------
//
//						BATTLE TRANSITION
//
//--------------------------------------------------------------------------------------------

newBattle.prototype.createTriangle = function(x1,y1,x2,y2,x3,y3,x,y)
{
	
	this.x1=x1;
	this.y1=y1;
	this.x2=x2;
	this.y2=y2;
	this.x3=x3;
	this.y3=y3;
	this.x=x;
	this.y=y;
	this.rotRadians=0;
	this.targetRadians=0;
	this.triX=0;
	this.triY=0;
}

newBattle.prototype.transitionIn = function()
{
	RenderMap();
	var w = 320;
	var h = 240;
	var wh = w/2;
	var hh = h/2;
	var img = GrabImage(0,0,w,h);
	var triArray = new Array(8); // 8 triangles.
	var count=-1;
	var x1 = 0;
	var y1 = 0;
	var x2 = 0;
	var y2 = hh;
	//create the triangles.
	for(var i=0;i<2;i++)
	{
		count++;
		triArray[count] = new this.createTriangle(wh,hh,0,i * hh,0,hh + i * hh,0,i * hh);
	}
	for(var i=0;i<2;i++)
	{
		count++;
		triArray[count] = new this.createTriangle(wh,hh,w,i * hh,w,hh + i * hh,wh,i * hh);
	}
	for(var i=0;i<2;i++)
	{
		count++;
		triArray[count] = new this.createTriangle(wh,hh,i * wh,h,wh + i * wh,h,i * wh,hh);
	}
	for(var i=0;i<2;i++)
	{
		count++;
		triArray[count] = new this.createTriangle(wh,hh,i * wh,0,wh + i * wh,0,i * wh,0);
	}
	var col = CreateColor(255,255,255,0);
	var triangles = [];
	var rand;
	var triangleImg;
	//separate screen into triangles.
	for(var i=0;i<triArray.length;i++)
	{
		rand = random(0,1);
		
		triangleImg = img.createSurface();
		triangleImg.setBlendMode(REPLACE);
		
		triArray[i].targetRadians = (rand==0) ? random(-1.5*Pi,-.5*Pi) : random(1.5*Pi,.5*Pi);
		
		for(var j=0;j<triArray.length;j++)
		{
			if(i!=j)
				triangleImg.triangle(triArray[j].x1,triArray[j].y1,triArray[j].x2,triArray[j].y2,triArray[j].x3,triArray[j].y3,col);
		}
		triangles[i]=triangleImg.cloneSection(triArray[i].x,triArray[i].y,wh,hh).createImage();
		
	}
	col.alpha = 255;
	//from this to the next comment, makes the screen crack for whatever milliseconds.
	//yucky, but I don't know how else to do it.
	triArray[0].triX = -3;
	triArray[1].triX = -3;
	triArray[2].triX = 2;
	triArray[3].triX = 2;
	triArray[4].triX = -1;
	triArray[6].triX = -1;
	var timey = GetTime();
	while(GetTime()-timey<1000)
	{
		Rectangle(0,0,w,h,col);
		for(var i=0;i<triangles.length;i++)
		{
			triangles[i].blit(triArray[i].x+triArray[i].triX,triArray[i].y+triArray[i].triY);
		}
		FlipScreen();
	}
	// Shatter.
	var startTime = GetTime();
	var transTime = 1000; // how long it should take.
	var perTrans = 0;
	while(startTime+transTime>GetTime())
	{
		perTrans = (GetTime()-startTime)/transTime;
		if((startTime+transTime)*2>GetTime())
			col.alpha=255-perTrans*255;
		this.drawImages();
		Rectangle(0,0,w,h,col);
		for(var i=0;i<triangles.length;i++)
		{
			triArray[i].triX = (triArray[i].x==0) ? -perTrans*(w/5) : perTrans*(w/5);
			triArray[i].triY = (triArray[i].y==0) ? -perTrans*(h/5) : perTrans*(h/5);
			triArray[i].rotRadians = perTrans * triArray[i].targetRadians;
			triangles[i].rotateBlitMask(triArray[i].x+triArray[i].triX,triArray[i].y+triArray[i].triY,triArray[i].rotRadians,col);
		}
		FlipScreen();
	}
}