function flash(length)
{
	if(!length)
		length=250;
	fadeOut(length*0.5,lightBlue);
	RenderMap();
	fadeIn(length*0.5,lightBlue);
	RenderMap();
}

//levitate object. has to be an object so it can be multiinstanceable and no global variables! woo!
// How to use:
// make a global variable for the levitate obj.
// ie, var levitatePerson;
// then when the person is created,
// levitatePerson = new Levitate("personnamehere");
// SetPersonScript(person, SCRIPT_COMMAND_GENERATOR, "levitatePerson.levitate();");
// LevitateImage("personnamehere",true);
// true is if you want the person to stretch on the y axis. very cool!
function Levitate(p, scale)
{
	this.spd = 0;
	this.interval=-0.01;
	this.y=GetPersonY(p);
	this.p = p;
	this.x = GetPersonX(p);
	this.scale=1;
	if(scale)
		this.scaleInterval=0.002;
	else
		this.scaleInterval=0.00;
}
//lolol levitate
Levitate.prototype.levitate=function()
{
	this.spd+=this.interval;
	this.y+=this.spd;
	this.scale+=this.scaleInterval;
	SetPersonXYFloat(this.p,this.x,this.y);
	SetPersonScaleFactor(this.p,1,this.scale);
	if((this.spd<.1 && this.spd>=0) || (this.spd>-.1 && this.spd<=0))
	{
		this.interval = -this.interval;
		this.spd = -this.spd;
	}
	if(this.spd>.5 || this.spd<-.5)
		this.interval = -this.interval;
	if((this.scale>1.5 && this.scaleInterval>0) || (this.scale<1 && this.scaleInterval<0))
		this.scaleInterval = -(this.scaleInterval);
}
/*function Levitate(p,scale)
{
	this.spd=0;
	this.y=GetPersonY(p);
	this.p=p;
	this.x=GetPersonX(p);
	this.scale=1;
	if(scale)
		this.scaleInterval=0.002;
	else
		this.scaleInterval=0;
}
//lolol levitate
Levitate.prototype.levitate=function()
{
	this.spd+=.025;
	this.scale+=this.scaleInterval;
	SetPersonXYFloat(this.p,this.x,this.y+Sin(this.spd)*16);
	SetPersonScaleFactor(this.p,1,this.scale);
	if((this.scale>1.5 && this.scaleInterval>0) || (this.scale<1 && this.scaleInterval<0))
		this.scaleInterval=-(this.scaleInterval);
}*/

//based on tiles.
function setXY(person,x,y)
{
	var data=GetPersonSpriteset(person);
	var width=data.base.x2 - data.base.x1;
	var height=data.base.y2 - data.base.y1;
	var halfx=x*16+Math.ceil(width*.5)-1;
	var halfy=y*16+Math.ceil(height*.5)-1;
	SetPersonX(person,halfx);
	SetPersonY(person,halfy);
}

function AtrusInn()
{
	if(Choice(20,190,"The cost is 30 gold. Would you like to stay here for the night?","Inn maid","Yes","No") == 0)
	{
		RenderMap();
		fadeOut();
		for(i=0;i<8;i++)
		{
			Char[i].hp = Char[i].maxhp;
		}
		RenderMap();
		fadeIn();
	}
	else
		talk("Have a pleasant day.","Inn maid");
}


function introScript()
{
	talkBox(0,90,"The Evil One's presence threatened the world until four heroes appeared. The Dwarven King, Garland; the White Witch, Elthra; the Swordsman Calisto; and the Spirit Gyuubi Lyanthir with the God Spirits Smaug and Phoenix sealed the Evil One deep under the earth, hoping for him never to return.","",true);
	talkBox(0,90,"And now, 986 years later, as the legacy of the four heroes disappeared into myth...","",true);
	talk("At last, the seal is weakening, after nearly a thousand years! \n Admittedly, it was quite strong, but those fools should have realized...","???");
	talk("Anything sealed is destined to return...!","???");
	talkBox(0,90,"A few years passed...","",true);
}

function playintrod()
{
	SetPersonX("Zero",31);
	SetPersonY("Zero",71);
	SetCameraX(0);
	//awwwh, Zero's a-sleepy!
	face("Zero","sleeping");
	emotion("Zero","asleep");
	RenderMap();
	fadeIn(2000);
	CreatePerson("Clair","Clair.rss",true);
	SetPersonDirection("Clair","north");
	Move("Clair",COMMAND_MOVE_NORTH,2,false);
	Move("Clair",COMMAND_MOVE_EAST,2,false);
	Move("Clair",COMMAND_MOVE_SOUTH,6,false);
	Move("Clair",COMMAND_MOVE_WEST,5,false);
	waitFor("Clair");
	talk("Zero! Wake up! WAKE UP, ZERO!!","Clair, Zero's Mother");
	face("Zero","south");
	destroyEmotion();
	emotion("Zero","shocked");
	talk("... Wha?!","Zero");
	destroyEmotion();
	talk("Don't you know what day it is today?","Clair");
	talk("...","Zero");
	talk("You're still half asleep! Today's your seventeenth birthday!","Clair");
	talk("...","Zero");
	talk("Come on! Get some fresh air outside! \n Oh, wait! I've baked you a cake! It'll be ready in about ten minutes. Come back then.","Clair");
	Move("Clair",COMMAND_MOVE_EAST,5,false);
	Move("Clair",COMMAND_MOVE_NORTH,6,false);
	Move("Clair",COMMAND_MOVE_WEST,2,false);
	Move("Clair",COMMAND_MOVE_SOUTH,2,false);
	waitFor("Clair");
	DestroyPerson("Clair");
	journal.newJournalEntry("Birthday","It's my birthday... and my mother woke me up early. I suppose I should head downstairs...");
	journal.addToEntry("Birthday","It's a beautiful day today. Only problem is that there are guards where the North used to be. I better find Father down to the South of Atrus.");
	MainMenu();
	Lithonite.AttachAll();
}

//Atrean Forest >> Goblin Fight

function AtreanForest()
{
	face("Zero","south");
	talk("This is the forest where we were found, Papo.","Zero");
	face("Papo","north");
	talk("This place gives me the creeps. Let's hurry up and find your dad!","Papo");
	emotion("Zero","shocked");
	emotion("Papo","shocked");
	face("Zero","east");
	face("Papo","east");
	CreatePerson("Goblin1","goblin.rss",true);
	setXY("Goblin1",7,14);
	CreatePerson("Goblin2","goblin.rss",true);
	setXY("Goblin2",7,15);
	crisis.play(true);
	Move("Goblin1",COMMAND_MOVE_NORTH,3);
	Move("Goblin2",COMMAND_MOVE_NORTH,3);
	waitFor("Goblin2");
	face("Papo","east");
	face("Zero","east");
	Move("Goblin1",COMMAND_MOVE_NORTH,3);
	Move("Goblin2",COMMAND_MOVE_NORTH,3);
	waitFor("Goblin2");
	face("Goblin1","west");
	face("Goblin2","west");
	talk("Uh oh! Goblins!","Papo","Papo");
	scriptBattle(1);
	destroyEmotion(emonum-1);
	destroyEmotion();
	//After Battle
	crisis.stop();
	DestroyPerson("Goblin1");
	DestroyPerson("Goblin2");
	talk("Whew, that was close. I thought we were goners there.","Papo");
	
	face("Papo","north");
	emotion("Papo","shocked");
	
	talk("Hey, you're wounded!","Papo");
	
	destroyEmotion();
	face("Zero","south");
	
	talk("It's just a small flesh wound!","Zero");
	
	talk(" ... This is no time to be fooling around! Go see Afaina now, she can heal your wounds.","Papo");
	
	face("Papo","west");
	
	talk("It's only a scratch...","Zero");
	
	face("Papo","north");
	emotion("Papo","annoyed");
	
	talk("Oh, come on!","Papo");
	
	destroyEmotion();
	Scenes.FightGoblins = true;
	if(choice(20,190,"Do you want to quick-jump to Afaina's house?","","Yes","No") == 1)
	{
		Lithonite.AttachAll();
		SetPersonScript("Papo",SCRIPT_ON_ACTIVATE_TALK,"_script();");
		return;
	}
	Lithonite.AttachAll();
	Goto("AfainasHouseDownstairs",6,17,1,"north",1000);
}

function AfainasHouseArrival()
{
	DetachInput();
	SetPersonSpeed("Zero",1);
	CreatePerson("Afaina2","Afaina.rss",true);
	panDir("N",1);
	Move("Zero",COMMAND_MOVE_NORTH,2);
	Move("Afaina2",COMMAND_MOVE_SOUTH,4);
	Move("Afaina2",COMMAND_MOVE_WEST,2);
	Move("Afaina2",COMMAND_MOVE_SOUTH,4);
	Move("Afaina2",COMMAND_MOVE_WEST,2);
	Move("Afaina2",COMMAND_MOVE_SOUTH,3);
	waitFor("Afaina2");
	emotion("Afaina2","shocked");
	talk("Zero! You're wounded! What happened? Are you OK? Let me help!","Afaina, Zero's best friend");
	destroyEmotion();
	Char[0].hp=Char[0].maxhp;
	Char[2].hp=Char[2].maxhp;
	talk("Afaina healed your party to full HP!");
	talk("There! That should do it!","Afaina","Afaina");
	CreatePerson("Alma2","pinkhairwoman.rss",true);
	Move("Alma2",COMMAND_MOVE_SOUTH,4);
	Move("Alma2",COMMAND_MOVE_WEST,2);
	Move("Alma2",COMMAND_MOVE_SOUTH,4);
	Move("Alma2",COMMAND_MOVE_WEST,3);
	Move("Alma2",COMMAND_MOVE_SOUTH,3);
	waitFor("Alma2");
	face("Alma2","east");
	talk("Afaina? What's the problem?","Alma, Afaina's mother");
	face("Afaina2","west");
	talk("Zero hurt himself.","Afaina");
	face("Alma2","south");
	talk("In the forest? Reckless as always, Zero. Why not leave the hunting to the men?","Alma");
	face("Alma2","east");
	face("Afaina2","south");
	talk("Hey, Zero! Let's go to your house now!","Afaina");
	waitm(100);
	IgnorePersonObstructions("Afaina2",true);
	Move("Afaina2",COMMAND_MOVE_SOUTH,1);
	waitFor("Afaina2");
	DestroyPerson("Afaina2");
	joinParty("Afaina");
	Lithonite.AttachAll();
	Goto("ZerosHouseDownstairs",4,13,1,"north",500);
}

function BirthdayCake()
{
	Scenes.BirthdayCake = true;
	setXY("Zero",4,13);
	Move("Zero",COMMAND_MOVE_NORTH,4);
	Move("Zero",COMMAND_MOVE_EAST,6);
	Move("Zero",COMMAND_MOVE_NORTH,3);
	waitFor("Zero");
	CreatePerson("Papo2","Papo.rss",true);
	IgnorePersonObstructions("Papo2",true);
	SetPersonX("Papo2",GetPersonX("Papo2")-8);
	SetPersonY("Papo2",GetPersonY("Papo2")-8);
	CreatePerson("Afaina2","Afaina.rss",true);
	IgnorePersonObstructions("Afaina2",true);
	IgnorePersonObstructions("Zero",true);
	IgnoreTileObstructions("Zero",true);
	IgnoreTileObstructions("Papo2",true);
	IgnoreTileObstructions("Afaina2",true);
	Move("Papo2",COMMAND_MOVE_WEST,1);
	Move("Afaina2",COMMAND_MOVE_EAST,1);
	waitFor("Afaina2");
	face("Papo2","east");
	face("Afaina2","west");
	face("Zero","west");
	talk("Come on. Let's go wait for your mom.","Papo");
	Move("Papo2",COMMAND_MOVE_NORTH,1);
	Move("Papo2",COMMAND_MOVE_EAST,7);
	Move("Papo2",COMMAND_MOVE_SOUTH,1);
	Move("Zero",COMMAND_MOVE_EAST,2);
	Move("Zero",COMMAND_MOVE_SOUTH,1);
	Move("Afaina2",COMMAND_MOVE_SOUTH,4);
	Move("Afaina2",COMMAND_MOVE_EAST,2);
	waitFor("Zero");
	face("Zero","south");
	waitFor("Afaina2");
	face("Afaina2","north");
	face("Zero","east");
	waitFor("Papo2");
	face("Papo2","west");
	face("Zero","north");
	CreatePerson("Clair2","Clair.rss",true);
	IgnorePersonObstructions("Clair2",true);
	IgnoreTileObstructions("Clair2",true);
	setXY("Clair2",11,1);
	Move("Clair2",COMMAND_MOVE_SOUTH,2);
	talk("You guys are here already!","Clair");
	Move("Clair2",COMMAND_MOVE_SOUTH,3);
	Move("Clair2",COMMAND_MOVE_EAST,2);
	waitFor("Clair2");
	face("Zero","east");
	face("Clair2","south");
	SetTile(13,7,1,95);
	talk("It's ready, Zero! Make a wish!","Clair");
	face("Zero","west");
	emotion("Zero","confused");
	waitm(2000);
	destroyEmotion();
	emotion("Zero","idea");
	waitm(2000);
	destroyEmotion();
	emotion("Zero","greedy");
	waitm(2000);
	destroyEmotion();
	emotion("Zero","greedy2");
	waitm(2000);
	destroyEmotion();
	face("Zero","east");
	emotion("Zero","shocked");
	waitm(2000);
	destroyEmotion();
	emotion("Zero","singing");
	waitm(2000);
	emotion("Clair2","sweatdrop");
	emotion("Afaina2","sweatdrop");
	emotion("Papo2","sweatdrop");
	waitm(3000);
	destroyEmotion(emonum-3);
	destroyEmotion(emonum-2);
	destroyEmotion(emonum-1);
	destroyEmotion();
	SetTile(13,7,1,86);
	waitm(250);
	talk("Finally!","Papo");
	talk("What did you wish for?","Afaina");
	face("Zero","south");
	talk("It's a secret.","Zero");
	talk("Come on! Why do you have to be like that! Oh no! I almost forgot your present! Here you go!","Afaina");
	//Receive Afaina's Charm
	talk("That's a protective charm! Apparently it brings the wearer good luck! \n ... What? You don't know how to put it on? It's simple.","Afaina","Afaina");
	talk("Access the menu, select Equip, and then accessory. It will come up with a list of all the accessories you have. Pretty convenient, huh?","Afaina");
	emotion("Papo2","shocked");
	talk("What was that sound?","Papo");
	destroyEmotion();
	Move("Papo2",COMMAND_MOVE_NORTH,1);
	Move("Papo2",COMMAND_MOVE_WEST,3);
	waitFor("Papo2");
	face("Papo2","north");
	face("Clair2","north");
	face("Zero","north");
	talk("I didn't hear anything.","Clair");
	face("Papo2","south");
	talk("It sounded like... marching footsteps. Coming from the North.","Papo");
	talk("The North? But that's where... surely not. No, it will just be... could it be...","Clair");
	talk("Let's go and check it out!","Zero");
	talk("No, Zero. You stay here, I'll go with Papo.","Clair");
	talk("Ha!","Papo");
	face("Zero","west");
	face("Afaina2","west");
	Move("Clair2",COMMAND_MOVE_WEST,5);
	Move("Clair2",COMMAND_MOVE_SOUTH,4);
	Move("Clair2",COMMAND_MOVE_WEST,4);
	Move("Clair2",COMMAND_MOVE_SOUTH,3);
	Move("Papo2",COMMAND_MOVE_WEST,4);
	Move("Papo2",COMMAND_MOVE_SOUTH,4);
	Move("Papo2",COMMAND_MOVE_WEST,1);
	Move("Papo2",COMMAND_MOVE_SOUTH,1);
	Move("Papo2",COMMAND_MOVE_WEST,4);
	Move("Papo2",COMMAND_MOVE_SOUTH,3);
	waitFor("Clair2");
	DestroyPerson("Clair2");
	waitFor("Papo2");
	DestroyPerson("Papo2");
	face("Zero","south");
	face("Afaina2","north");
	waitm(350);
	talk("So... Afaina...","Zero");
	face("Zero","west");
	face("Afaina2","west");
	emotion("Afaina2","shocked");
	emotion("Zero","shocked");
	CreatePerson("Papo3","Papo.rss",true);
	setXY("Papo3",3,12);
	SetPersonSpeed("Papo3",2);
	Move("Papo3",COMMAND_MOVE_NORTH,2);
	waitFor("Papo3");
	face("Papo3","east");
	destroyEmotion(emonum-1);
	destroyEmotion();
	talk("Zero! Afaina! Come quickly! This is terrible!","Papo");
	Move("Papo3",COMMAND_MOVE_SOUTH,2);
	waitFor("Papo3");
	DestroyPerson("Papo3");
	Move("Zero",COMMAND_MOVE_SOUTH,2);
	Move("Afaina2",COMMAND_MOVE_WEST,2);
	waitFor("Zero");
	Move("Zero",COMMAND_MOVE_WEST,2);
	face("Afaina2","north");
	waitFor("Zero");
	Move("Zero",COMMAND_MOVE_WEST,6);
	Move("Zero",COMMAND_MOVE_SOUTH,4);
	Move("Afaina2",COMMAND_MOVE_NORTH,1);
	Move("Afaina2",COMMAND_MOVE_WEST,7);
	Move("Afaina2",COMMAND_MOVE_SOUTH,4);
	waitFor("Zero");
	Lithonite.AttachAll();
	Goto("Atrus",12,47,1,"south",500);
}

function AerionsDeath()
{
	//Create Afaina
	
	//Create Papo
	CreatePerson("Papo","Papo.rss",true);
	setXY("Papo",35,35);
	face("Papo","north");
	IgnorePersonObstructions("Papo",true);
	//Create Clair
	CreatePerson("Clair","Clair.rss",true);
	setXY("Clair",34,35);
	face("Clair","north");
	IgnorePersonObstructions("Clair",true);
	//Create Aerion
	CreatePerson("Aerion","Aerion.rss",true);
	setXY("Aerion",35,34);
	face("Aerion","north");
	IgnorePersonObstructions("Aerion",true);
	//Create Alma
	CreatePerson("Alma","pinkhairwoman.rss",true);
	setXY("Alma",37,36);
	face("Alma","north");
	IgnorePersonObstructions("Alma",true);
	//Create Neville
	CreatePerson("Neville","Neville.rss",true);
	setXY("Neville",37,35);
	face("Neville","north");
	IgnorePersonObstructions("Neville",true);
	//Create Saiken
	CreatePerson("Saiken","HenchmanLeader.rss",true);
	setXY("Saiken",35,31);
	face("Saiken","south");
	IgnorePersonObstructions("Saiken",true);
	//Create Soldier1
	CreatePerson("Soldier1","Henchman.rss",true);
	setXY("Soldier1",34,30);
	face("Soldier1","south");
	//Create Soldier2
	CreatePerson("Soldier2","Henchman.rss",true);
	setXY("Soldier2",35,29);
	face("Soldier2","south");
	//Create Soldier3
	CreatePerson("Soldier3","Henchman.rss",true);
	setXY("Soldier3",36,30);
	face("Soldier3","south");
	//do events
	Move("Zero",COMMAND_MOVE_EAST,8);
	Move("Zero",COMMAND_MOVE_NORTH,8);
	Move("Zero",COMMAND_MOVE_EAST,8);
	Move("Zero",COMMAND_MOVE_NORTH,3);
	Move("Zero",COMMAND_MOVE_EAST,6);
	Move("Afaina",COMMAND_MOVE_SOUTH,1);
	Move("Afaina",COMMAND_MOVE_EAST,8);
	Move("Afaina",COMMAND_MOVE_NORTH,8);
	Move("Afaina",COMMAND_MOVE_EAST,8);
	Move("Afaina",COMMAND_MOVE_NORTH,3);
	Move("Afaina",COMMAND_MOVE_EAST,5);
	CameraSlide(GetCameraX(),GetCameraY(),25,26,false,false,true,0,9000);
	waitFor("Zero");
	face("Zero","north");
	waitFor("Afaina");
	face("Afaina","north");
	Move("Saiken",COMMAND_MOVE_SOUTH,1);
	waitFor("Saiken");
	Move("Clair",COMMAND_MOVE_NORTH,1);
	talk("No! There is nothing here for you!","Clair");
	waitFor("Clair");
	Move("Aerion",COMMAND_MOVE_NORTH,1);
	waitFor("Aerion");
	talk("Don't come any further!","Aerion, Zero's father");
	talk("What do you think you're doing, telling Prince Saiken of Valhalla what to do?","Saiken Valhalla, the dark prince");
	flash();
	SetPersonSpeed("Aerion",4);
	Move("Aerion",COMMAND_MOVE_SOUTH,1,COMMAND_FACE_NORTH);
	waitFor("Aerion");
	face("Aerion","dead");
	talk("Urrgh...","Aerion");
	SetPersonSpeed("Clair",2);
	SetPersonSpeed("Zero",2);
	Move("Clair",COMMAND_MOVE_WEST,1,COMMAND_FACE_EAST);
	Move("Zero",COMMAND_MOVE_NORTH,1);
	waitFor("Zero");
	SetPersonSpeed("Zero",1);
	talk("You bastard!","Zero");
	//Create Soldier4
	CreatePerson("Soldier4","Henchman.rss",true);
	setXY("Soldier4",34,47);
	face("Soldier4","south");
	//Create Soldier5
	CreatePerson("Soldier5","Henchman.rss",true);
	setXY("Soldier5",35,47);
	face("Soldier5","south");
	//resume
	Move("Soldier4",COMMAND_MOVE_NORTH,4);
	Move("Soldier5",COMMAND_MOVE_NORTH,4);
	CameraSlide(0,0,0,5,true,false,true,0,1000);
	waitFor("Soldier5");
	face("Zero","south");
	face("Papo","south");
	face("Clair","south");
	face("Afaina","south");
	face("Alma","south");
	face("Neville","south");
	talk("How dare you insult Prince Saiken!","Henchman");
	SetPersonSpeed("Zero",.5);
	SetPersonSpeed("Afaina",.5);
	SetPersonSpeed("Papo",.5);
	Move("Zero",COMMAND_MOVE_SOUTH,2);
	Move("Afaina",COMMAND_MOVE_SOUTH,2);
	Move("Papo",COMMAND_MOVE_SOUTH,1);
	Move("Soldier4",COMMAND_MOVE_NORTH,4);
	Move("Soldier5",COMMAND_MOVE_NORTH,4);
	waitFor("Afaina");
	face("Afaina","east");
	waitFor("Zero");
	monsterGenerator(10,10);
	startbattle();
	flash();
	Move("Soldier5",COMMAND_MOVE_SOUTH,1,COMMAND_FACE_NORTH);
	waitFor("Soldier5");
	waitm(500);
	face("Soldier5","dead");
	waitm(500);
	flash();
	Move("Soldier4",COMMAND_MOVE_SOUTH,1,COMMAND_FACE_NORTH);
	waitFor("Soldier4");
	waitm(500);
	face("Soldier4","dead");
	waitm(500);
	CameraSlide(0,0,0,-5,true,false,true,0,1000);
	face("Zero","north");
	face("Papo","north");
	face("Clair","north");
	face("Afaina","north");
	face("Alma","north");
	face("Neville","north");
	talk("Pitiful... You can't even best mere children. You don't deserve to live.","Prince Saiken");
	flash();
	CameraSlide(0,0,0,2,true,false,true,0,1000);
	flash();
	talk("That man... He has a sphere... just like me... AARGH! My arm...!","Zero");
	waitm(500);
	face("Zero","dead");
	waitm(500);
	CameraSlide(0,0,0,-2,true,false,true,0,1000);
	talk("Uurgh... What is this pain in my arm... Forget it! Grab the descendant of the White Witch and let's go!","Prince Saiken");
	talk("I don't know what you're talking about! There is no descendant here!","Alma");
	Move("Saiken",COMMAND_MOVE_EAST,2);
	CameraSlide(0,0,2,0,true,false,true,0,1000);
	waitFor("Saiken");
	face("Saiken","south");
	talk("Then you're coming with us until we find her!","Prince Saiken");
	talk("NO!","Neville, Afaina's father");
	SetPersonSpeed("Neville",4);
	Move("Neville",COMMAND_MOVE_NORTH,2);
	waitFor("Neville");
	flash();
	Move("Neville",COMMAND_MOVE_EAST,2,COMMAND_FACE_WEST);
	waitFor("Neville");
	face("Neville","dead");
	talk("Such a shame. You can't even scratch me...","Prince Saiken");
	talk("You... bastard! Alma...!","Neville");
	Move("Alma",COMMAND_MOVE_EAST,2);
	Move("Alma",COMMAND_MOVE_NORTH,2);
	Move("Saiken",COMMAND_MOVE_SOUTH,2);
	Move("Saiken",COMMAND_MOVE_EAST,1);
	waitFor("Alma");
	flash();
	Move("Alma",COMMAND_MOVE_EAST,2,COMMAND_FACE_WEST);
	talk("Revital - AAARGH!","Alma","Alma");
	Move("Saiken",COMMAND_MOVE_EAST,2);
	talk("So, you're the descendant, huh?","Prince Saiken");
	talk("NO!","Alma");
	talk("Let's go.","Prince Saiken");
	Move("Saiken",COMMAND_MOVE_WEST,2);
	Move("Alma",COMMAND_MOVE_WEST,3,COMMAND_FACE_EAST);
	Move("Saiken",COMMAND_MOVE_NORTH,3);
	Move("Alma",COMMAND_MOVE_NORTH,3,COMMAND_FACE_SOUTH);
	Move("Saiken",COMMAND_MOVE_NORTH,6);
	Move("Alma",COMMAND_MOVE_NORTH,6,COMMAND_FACE_SOUTH);
	Move("Soldier1",COMMAND_MOVE_NORTH,6);
	Move("Soldier2",COMMAND_MOVE_NORTH,6);
	Move("Soldier3",COMMAND_MOVE_NORTH,6);
	waitm(1000);
	talk("Help me!","Alma");
	CameraSlide(0,0,-2,0,true,false,true,0,2000);
	waitFor("Alma");
	DestroyPerson("Alma");
	DestroyPerson("Saiken");
	DestroyPerson("Soldier1");
	DestroyPerson("Soldier2");
	DestroyPerson("Soldier3");
	//CameraSlide(0,0,2,0,true,false,true,0,1000);
	talk("Quick! I have to help these people!","Afaina");
	Move("Afaina",COMMAND_MOVE_NORTH,2);
	Move("Afaina",COMMAND_MOVE_EAST,1);
	waitFor("Afaina");
	face("Afaina","south");
	waitm(1000);
	Move("Afaina",COMMAND_MOVE_EAST,2);
	Move("Afaina",COMMAND_MOVE_NORTH,2);
	waitFor("Afaina");
	face("Afaina","west");
	waitm(1000);
	Move("Afaina",COMMAND_MOVE_EAST,3);
	waitFor("Afaina");
	face("Afaina","north");
	waitm(1000);
	talk("... It's no good. \n I can't save a single life.","Afaina");
	talk("... Afaina...","Neville");
	talk("Father! Are you okay?","Afaina");
	talk("... I'm sorry...","Neville");
	talk("It's not your fault! Don't you ever blame yourself! And don't worry, I'm going to get Mother back.","Afaina");
	talk("... Be careful.","Neville");
	talk("I will, Father.","Afaina");
	Move("Zero",COMMAND_MOVE_NORTH,2);
	Move("Zero",COMMAND_MOVE_EAST,5);
	waitFor("Zero");
	face("Zero","north");
	talk("I'm coming with you.","Zero");
	face("Afaina","south");
	talk("Zero!!","Afaina");
	talk("No, Zero! It's too dangerous! You were wounded without him even touching you!","Clair");
	talk("... Let him go... He's already... even... stronger...","Aerion");
	waitm(1000);
	talk("...","Clair");
	waitm(1000);
	talk("Very well... Zero... never forget who you are.","Clair");
	Scenes.DownfallOfAtrus = true;
	
}