/* 
 * function onEnterMap()
 * 
 * It's called whenever you enter a map. It's use?
 *  To intialise things in the map, such as switches,
 *  NPCs, and changed tiles.
 * 
 */
function onEnterMap()
{
	
	var location = GetCurrentMap();
	var person = "";
	
	switch(location)
	{
		case "AtrusHouse2.rmp":
		{
			person="oldman_1";
			face(person,"west");
			SetPersonScript(person, SCRIPT_ON_ACTIVATE_TALK, "_script();");
		}
		case "AfainasHouseDownstairs.rmp":
		{
			
			person="Afaina";
			SetPersonScript(person, SCRIPT_ON_ACTIVATE_TALK, "_script();");
			SetPersonScript(person, SCRIPT_COMMAND_GENERATOR, "_randomMove();");
			person="Alma";
			SetPersonScript(person, SCRIPT_ON_ACTIVATE_TALK, "_script();");
			SetPersonScript(person, SCRIPT_COMMAND_GENERATOR, "_randomMove();");
			if(Scenes.FightGoblins)
			{
				Lithonite.DetachAll();
				DestroyPerson("Afaina");
				DestroyPerson("Alma");
				SetDelayScript(1,"AfainasHouseArrival();");
			}
			break;
		}
		case "ZerosHouseUpstairs.rmp":
		{
			AttachInput("Zero");
			if (!Scenes.Intro)
			{
				Scenes.Intro = true;
				playintrod();
			}
			break;
		}
		
		case "ZerosHouseDownstairs.rmp":
		{
			person = "Papo_1";
			face(person,"sleep");
			SetPersonFrameRevert(person, 1);
			SetPersonX(person,GetPersonX(person)+8);
			SetPersonScript(person, SCRIPT_ON_ACTIVATE_TALK, "_script();");
			if(Scenes.PapoJoins)
				DestroyPerson(person);
			person = "Clair";
			face(person,"west");
			SetPersonScript(person, SCRIPT_COMMAND_GENERATOR, "_randomMove();");
			SetPersonScript(person, SCRIPT_ON_ACTIVATE_TALK, "_script();");
			if(Scenes.BirthdayCake)
			{
				Lithonite.DetachAll();
				DestroyPerson("Clair");
				SetDelayScript(1,"BirthdayCake();");
			}
			break;
		}
		//********************************************
		//               ATRUS
		//********************************************
		case "Atrus.rmp":
		{
			
			person = "oldman_1";
			//SetPersonFrameRevert(person, 1);
			SetPersonScript(person, SCRIPT_ON_ACTIVATE_TALK, "_script();");
			Martel=new Levitate("oldman_1");
			SetPersonScript(person, SCRIPT_COMMAND_GENERATOR, "Martel.levitate();");
			person = "maidblonde_1";
			face(person,"west");
			SetPersonFrameRevert(person, 1);
			SetPersonScript(person, SCRIPT_ON_ACTIVATE_TALK, "_script();");
			SetPersonScript(person, SCRIPT_COMMAND_GENERATOR, "_randomMove();");
			
			person = "pinkhairwoman_1";
			face(person,"north");
			SetPersonScript(person, SCRIPT_ON_ACTIVATE_TALK, "_script();");
			
			person = "pinkhairgirl_1";
			face(person,"north");
			SetPersonScript(person, SCRIPT_ON_ACTIVATE_TALK, "_script();");
			SetPersonScript(person, SCRIPT_COMMAND_GENERATOR, "_randomMove();");
			person = "bluehair_1";
			face(person,"west");
			SetPersonScript(person, SCRIPT_ON_ACTIVATE_TALK, "_script();");
			person = "soldier_1";
			face(person,"south");
			SetPersonScript(person, SCRIPT_ON_ACTIVATE_TALK, "_script();");
			if(Scenes.DownfallOfAtrus)
				DestroyPerson(person);
			person = "soldier_2";
			face(person,"south");
			SetPersonScript(person, SCRIPT_ON_ACTIVATE_TALK, "_script();");
			if(Scenes.DownfallOfAtrus)
				DestroyPerson(person);
			person = "soldier_3";
			face(person,"south");
			SetPersonScript(person, SCRIPT_ON_ACTIVATE_TALK, "_script();");
			if(Scenes.DownfallOfAtrus)
				DestroyPerson(person);
			if(Scenes.PapoJoins && !Scenes.BirthdayCake)
			{
				person="warpToMapSouth1";
				SetPersonScript(person, SCRIPT_ON_ACTIVATE_TOUCH, "_script();");
				person="warpToMapSouth2";
				SetPersonScript(person, SCRIPT_ON_ACTIVATE_TOUCH, "_script();");
				person="warpToMapSouth3";
				SetPersonScript(person, SCRIPT_ON_ACTIVATE_TOUCH, "_script();");
			}
			if (Scenes.DownfallOfAtrus)
			{
				Lithonite.DetachAll();
				SetPersonSpeed("Zero",1);
				IgnorePersonObstructions("Zero",true);
				IgnoreTileObstructions("Zero",true);
				DestroyPerson("oldman_1");
				DestroyPerson("maidblonde_1");
				DestroyPerson("bluehair_1");
				DestroyPerson("pinkhairgirl_1");
				CreatePerson("Afaina","Afaina.rss",true);
				face("Afaina","south");
				setXY("Afaina",12,46);
				IgnorePersonObstructions("Afaina",true);
				SetDelayScript(1,"AerionsDeath();");
			}
			else
				SetDelayScript(16,"SetTownText(\"Atrus\",true);");
			break;
		}
		//********************************************
		//               ATREAN FOREST
		//********************************************
		case "Atrean Forest.rmp":
		{
			if(Scenes.PapoJoins)
			{
				Lithonite.DetachAll();
				SetPersonSpeed("Zero",1);
				CreatePerson("Papo","Papo.rss",true);
				setXY("Papo",1,9);
				Move("Zero",COMMAND_MOVE_EAST,2,false);
				Move("Papo",COMMAND_MOVE_EAST,2,false);
				DestroyPerson("goblin");
				SetDelayScript(1,"AtreanForest();");
			}
			else
			{
				SetDelayScript(16,"SetTownText(\"Atrean Forest\",true);");
				person="goblin";
				SetPersonScript(person, SCRIPT_ON_ACTIVATE_TOUCH, "touchBattle(1);");
				SetPersonScript(person, SCRIPT_COMMAND_GENERATOR, "_monsterMove();");
			}
			break;
		}
		//********************************************
		//
		//               WORLD MAP
		//
		//********************************************
		case "worldmap.rmp":
		{
			
			break;
		}
		
		default:
		{
			Abort("onEnterMap could not find the map \"" + location + "\".");
		}
    
	}
  
}



