//------------------------------------------
//
// WAIT TILL SOMEONE STOPS MOVING.
//
//------------------------------------------

function waitFor(p)
{
	var realtime=GetTime();
	fps_box=GetMapEngineFrameRate();
	while(!IsCommandQueueEmpty(p))
	{
		for(var i=0;i<(GetTime()-realtime)*fps_box/1000;i++)
		{
				UpdateMapEngine();
		}
		realtime=GetTime();
		RenderMap();
		FlipScreen();
	}
	return;
}

//------------------------------------------
//
//MOVEMENT (for cinematics and such)
//
//------------------------------------------


function Move(name, command, tiles, dir)
{
	var speed = GetPersonSpeedX(name);
	switch (command)
	{
		case COMMAND_MOVE_NORTH:
			if(!dir)
				QueuePersonCommand(name, COMMAND_FACE_NORTH, false);
			else
				QueuePersonCommand(name, dir, false);
		break;

		case COMMAND_MOVE_SOUTH:
			if(!dir)
				QueuePersonCommand(name, COMMAND_FACE_SOUTH, false);
			else
				QueuePersonCommand(name, dir, false);
		break;

		case COMMAND_MOVE_EAST:
			if(!dir)
				QueuePersonCommand(name, COMMAND_FACE_EAST, false);
			else
				QueuePersonCommand(name, dir, false);
		break;

		case COMMAND_MOVE_WEST:
			if(!dir)
				QueuePersonCommand(name, COMMAND_FACE_WEST, false);
			else
				QueuePersonCommand(name, dir, false);
		break;
	}
	for (var i=0;i<16*tiles/speed;++i)
		QueuePersonCommand(name, command, false);
}

//------------------------------------------
//
//RANDOM MOVEMENT
//
//------------------------------------------


function _randomMove()
{
	var p=GetCurrentPerson();
	var px=GetPersonX(p);
	var py=GetPersonY(p);
	var duration=Floor(Random()*8)+16;
	var rnd=Floor(Random()*12);
	switch(rnd)
	{
		case 0: // Move north
			QueuePersonCommand(p, COMMAND_FACE_NORTH, false);
			for(var i = 1;i <=16;i++)
			{
				if(IsPersonObstructed(p, px, py - i))
					break;
				QueuePersonCommand(p, COMMAND_MOVE_NORTH, false);
			}
		break;
		case 1: // Move east
			QueuePersonCommand(p, COMMAND_FACE_EAST, false);
			for(var i=1;i<=16;i++)
			{
				if(IsPersonObstructed(p, px + i, py))
					break;
				QueuePersonCommand(p, COMMAND_MOVE_EAST, false);
			}
		break;
		case 2: // Move south
			QueuePersonCommand(p, COMMAND_FACE_SOUTH, false);
			for(var i = 1;i <= 16;i++)
			{
				if(IsPersonObstructed(p, px, py + i))
					break;
				QueuePersonCommand(p, COMMAND_MOVE_SOUTH, false);
			}
		break;
		case 3: // Move west
			QueuePersonCommand(p, COMMAND_FACE_WEST, false);
			for(var i = 1;i<=16;i++)
			{
				if(IsPersonObstructed(p, px - i, py)) break;
				QueuePersonCommand(p, COMMAND_MOVE_WEST, false);
			}
		break;
		default: // Wait
			for(var i=0;i<duration;i++)
			{
				QueuePersonCommand(p, COMMAND_WAIT, false);
			}
  
  }
}

//MONSTER MOVEMENT
// checks to see if the player is in a square area (5 tiles for this one) from the monster.
// if the player is, the monster will attempt to walk to the player.
function _monsterMove()
{
	var p=Lithonite.GIP;
	var m=GetCurrentPerson();
	var px=GetPersonX(p);
	var py=GetPersonY(p);
	var mx=GetPersonX(m);
	var my=GetPersonY(m);
	if((px-mx==16&&py-my>-16&&py-my<16)||(mx-px==16&&py-my>-16&&py-my<16)||(my-py==16&&px-mx>-16&&px-mx<16)||(py-my==16&&px-mx>-16&&px-mx<16))
	{
		CallPersonScript(m,SCRIPT_ON_ACTIVATE_TOUCH);
	}
	else if(px-mx<80&&px-mx>-80&&py-my<80&&py-my>-80)
	{
		if(mx<px)
		{
			if(GetObstructingTile(m,mx+1,my)==-1)
				SetPersonX(m,mx+1);
			SetPersonDirection(m,"east");
		}
		else if(mx>px)
		{
			if(GetObstructingTile(m,mx-1,my)==-1)
				SetPersonX(m,mx-1);
			SetPersonDirection(m,"west");
		}
		if(my<py)
		{
			if(GetObstructingTile(m,mx,my+1)==-1)
				SetPersonY(m,my+1);
			SetPersonDirection(m,"south");
		}
		else if(my>py)
		{
			if(GetObstructingTile(m,mx,my-1)==-1)
				SetPersonY(m,my-1);
			SetPersonDirection(m,"north");
		}
	}
	else
		_randomMove();
	
}
//------------------------------------------
//
// NPC FACE PLAYER
//
//------------------------------------------

function npcface(person_name)
{
  var directions = ["north", "northeast", "east", "southeast",
                    "south", "southwest", "west", "northwest"];

  var opposite_directions = ["south", "south", "west", "west",
                             "north", "north", "east", "east"];

  var direction_index = -1;

  if (IsInputAttached()) {
    var player_direction = GetPersonDirection(GetInputPerson());

    for (var i = 0;i < directions.length;++i) { 
      if (directions[i] == player_direction) 
        direction_index = i;
    }

    if (direction_index > -1) { 
      SetPersonDirection(person_name, opposite_directions[direction_index]);
    } 
  }

  return (direction_index > -1);
}

//------------------------------------------
//
//WARPING
//
//------------------------------------------

function Goto(map,x,y,layer,dir,length)
{
	var person = GetInputPerson();
	if (length == undefined)
		length = 250;
	ClearKeyQueue();
	QueuePersonScript(person,"DetachInput();",false);
	RenderMap();
	fadeOut(length);
	gTownDelay = 0;
	if (map)
		ChangeMap(map+".rmp");
	SetPersonX(person,x*16+7);
	SetPersonY(person,y*16+7);
	SetCameraX(GetPersonX(person));
	SetCameraY(GetPersonY(person));
	SetPersonLayer(person,layer);
	if (dir)
		SetPersonDirection(person,dir);
	SetPersonFrame(person,0);
	RenderMap();
	fadeIn(length);
	AttachInput(person);
	FlipScreen();
}


//----------------------------------
//FADE OUT (WITH COLORS AND SUCH)
//----------------------------------

function fadeOut(msecs, color)
{
	var image = GrabImage(0, 0, GetScreenWidth(), GetScreenHeight());
	var time = GetTime();
	var col;
	var factor=0;
	if(color)
		col=color;
	else
		col = CreateColor(0, 0, 0, 255);
	while(GetTime() - time < msecs)
	{
		col.alpha = (GetTime() - time) * 255 / msecs;
		factor = (GetTime() - time) / msecs + 1;
		image.zoomBlit(
			MapToScreenX(0, GetCameraX()) - image.width * factor * (MapToScreenX(0, GetCameraX()) / GetScreenWidth()),
			MapToScreenY(0, GetCameraY()) - image.height* factor * (MapToScreenY(0, GetCameraY()) /GetScreenHeight()),
			factor
		);
		RenderMap();
		ApplyColorMask(col);
		FlipScreen();
	}
}


//------------------------------------
//FADE IN (WITH COLORS AND SUCH)
//------------------------------------

function fadeIn(msecs, color)
{
	var time = GetTime();
	var col;
	if(color)
		col=color;
	else
		col = CreateColor(0, 0, 0, 255);
	while(GetTime() - time < msecs)
	{
		col.alpha = 255 - (GetTime() - time) * 255 / msecs;
		RenderMap();
		ApplyColorMask(col);
		FlipScreen();
	}
}



