//___________________________________
//                                   \
// MOVEMENT CORE. Glues all together.
//___________________________________/

//___________________________________
//                                   \
  RequireScript("lithonite.js");
//___________________________________/


//----------------------------------------------------------------------------//

/*
	This is the only way to declare Lithonite. 
	(you could also declare it like: var L= new LithoniteEngine("L");
	as long as those 2 names are the same).
	A second parameter is optional: If you will never change the main character:
	var L= new LithoniteEngine("L",'bob');
*/
var Lithonite= new LithoniteEngine("Lithonite");

/*
	The default pixels lookup value for anti-obstruction is 8,make it bigger so
	the effect is more obvious.
*/
Lithonite.LMaxLookupX=10;
Lithonite.LMaxLookupY=13;

/*
	short-write slope(),just like: sin=Math.sin;
	Only this doesnt work: slope=Lithonite.slope;
	Because SLOPES contains references to "this.",which becomes non-defined outside
	the Lithonite Object.
*/
function slope(c){Lithonite.slope(c)};

/*
	Add you custom-made slope type (thing to run inside a Zone). See slope() in lithonite.js
	This example swaps the cursor keys (left & up,right & down).
	Its defined in the Zone at the upper-right corner of this demo.
	Note that zones have a value of 8 wait cycles before triggering,so it possible that you can enter a zone up to 8 
	pixels before it triggers. The lower the number,the slower the game though. You can make the zone a little bit 
	bigger,but that is not always possible
*/
Lithonite.SLOPES['myslope']=function()
{
	if(!this.moving)return;
	this.active=false;
	var newX=-this.move_x+this.move_y;
	var newY=-this.move_y+this.move_x;
	SetPersonDirection(this.GIP,this.getMoveDir(this.hist_y,this.hist_x));
	//Also try this,it somewhat replaces this whole block of repos() and deObstruct(): 
	// this.shove(GetPersonSpeedX(this.GIP)*newX,GetPersonSpeedY(this.GIP)*newY);
	if(!this.repos(GetPersonSpeedX(this.GIP)*newX,GetPersonSpeedY(this.GIP)*newY))
	{
		this.active=true;
		this.move_x=this.move_y;
		this.move_y=this.move_x;
		this.deObstruct();
		this.active=false;
	}
};


//----------------------------------------------------------------------------//
/*
	In order to activate all extra things each drawn frame,we need to hook
	our functions.

*/
//SetUpdateScript("Movement_Update()");	// calls 'Movement_Update()' before all map layers are rendered
//SetRenderScript("Render_Update()");	// calls 'Render_Update()'   after  all map layers are rendered

//----------------------------------------------------------------------------//


function Movement_Update() 
{
	OnKEYDown();
	if(Lithonite.justStopped())OnKEYUp();
	if(IsKeyPressed(GetTalkActivationKey())&&Lithonite.moving==0)
	{
		QueuePersonCommand(Lithonite.GIP,Lithonite.getCommand(0,Lithonite.hist_x,Lithonite.hist_y),true);
		Lithonite.moving=1;
	}
}




//----- KEY UP AND KEY DOWN -----//
function OnKEYDown()
{
	Lithonite.setInputPerson();
	Lithonite.checkDashing(KEY_X);
	Lithonite.calcVectors();
	Lithonite.doSlope();
}//End_Function:OnKEYDown


function OnKEYUp()
{
  Lithonite.standStill(); //Set a face_<> direction and unsets justStopped(),justStopped() is now false again.
}

//----- STATUS BAR + Weather effects + Overworld effect-----//
function Render_Update()
{
	//Here go all UpdateAndDraw() functions. This demo has none.
	Lithonite.deObstruct();
}