/*
 * GAME SCRIPT
 *
 * This pretty much stores all of the speech, movement,
 * and cut-scenes of the entire game. You know, the creators
 * behind Sphere should have put a little more effort into
 * protecting games from modification. Oh well, what are you
 * going to do? Besides, it's nice to muck around with other
 * people's work... I'm rambling. Have fun with this!
 *
 * This just contains one massive function: _script. It
 * channels data based on where any given character is, and
 * what has yet to be done in the story.
 *
 */

var g_TalkTriggered=false;
var g_TalkToPapo=false;
function _script()
{
	var person=GetCurrentPerson();
	if(!g_TalkTriggered)
	{
		g_TalkTriggered = true;
		var location = GetCurrentMap();
		switch(location)
		{
			//***********************************************************
			//                           ATRUS HOUSE #2
			//***********************************************************
			case "AtrusHouse2.rmp":
			{
				talk("I'm cold. Can you get me some beer? -hic-!","old man");
				break;
			}
			//***********************************************************
			//
			//                            AFAINA'S HOUSE
			//
			//***********************************************************
			case "AfainasHouseDownstairs.rmp":
			{
				switch(person)
				{
					case "Afaina":
					{
						// Stop the NPC from moving around.
						SetPersonScript(person, SCRIPT_COMMAND_GENERATOR, "");
						npcface(person);
						talk("Hi, Zero! Happy birthday! I've got you a present, but it's a S-E-C-R-E-T! You can have it after you've eaten your cake!","Afaina, Zero's best friend");
						SetPersonScript(person, SCRIPT_COMMAND_GENERATOR, "_randomMove();");
						break;
					}
					case "Alma":
					{
						// Stop the NPC from moving around.
						SetPersonScript(person, SCRIPT_COMMAND_GENERATOR, "");
						npcface(person);
						talk("Hello, Zero. My husband has gone hunting with your father. I hope they come home soon.","Alma, Afaina's mother");
						SetPersonScript(person, SCRIPT_COMMAND_GENERATOR, "_randomMove();");
						break;
					}
					case "toUpstairs":
					{
						talk("I'm not allowed to go upstairs...","Zero");
						Move("Zero",COMMAND_MOVE_SOUTH,1);
					}
					case "toUpstairs2":
					{
						talk("I'm not allowed to go upstairs...","Zero");
						Move("Zero",COMMAND_MOVE_SOUTH,1);
					}
				}
				break;
			}
			//***********************************************************
			//
			//                              ATREAN FOREST
			//
			//***********************************************************
			case "Atrean Forest.rmp":
			{
				switch(person)
				{
					case "Papo":
					{
						npcface(person);
						if(choice("Let's go to Afaina's house!","Papo","Fine","No")==1)
							talk("Whatever, Zero...","Papo");
						else
							Goto("AfainasHouseDownstairs",6,17,1,"north",1000);
						break;
					}
				}
				break;
			}
			//***********************************************************
			//
			//                             ZERO'S HOUSE
			//
			//***********************************************************
			case "ZerosHouseDownstairs.rmp":
			{
				switch(person)
				{
					case "Papo_1":
					{
						if(!Scenes.BotherPapo)
						{
							talk("Grumble... Mumble...","Papo, Zero's talking dog");
							npcface(person);
							talk("... Huh? Hey, Zero! It's too early! Let me have my beauty sleep!","Papo");
							face(person,"sleep");
							Scenes.BotherPapo=true;
						}
						else
							talk("Stop bothering me, Zero!","Papo");
						break;
					}
					case "Clair":
					{
						// Stop the NPC from moving around.
						SetPersonScript(person, SCRIPT_COMMAND_GENERATOR, "");
						ClearPersonCommands(person);
						npcface(person);
						talk("The cake isn't ready yet. Maybe you should go find your father. He's in the forest down south. Just be back soon!","Clair");
						Scenes.TalkToMom = true;
						// Reinstate NPC's movement.
						SetPersonScript(person, SCRIPT_COMMAND_GENERATOR, "_randomMove();");
						break;
					}
				}
				break;
			}
			//***********************************************************
			//
			//                                ATRUS
			//
			//***********************************************************
			case "Atrus.rmp":
			{
				switch(person)
				{
					case "soldier_1":
					{
						talk("Stop! It's dangerous that way! Goblins roam the road between here and Figuera.","Guard");
						break;
					}
					case "soldier_2":
					{
						talk("Stop! It's dangerous that way! Goblins roam the road between here and Figuera.","Guard");
						break;
					}
					case "soldier_3":
					{
						talk("Stop! It's dangerous that way! Goblins roam the road between here and Figuera.","Guard");
						break;
					}
					case "oldman_1":
					{
						// Person faces Zero.
						npcface(person);
						// And speaks.
						talk("The forest to the south is dangerous, but it's the only place to find meat. Your father sure is brave, fetching the meat for us.","old man");
						break;
						
					}
					case "maidblonde_1":
					{
						// Stop the NPC from moving around.
						SetPersonScript(person, SCRIPT_COMMAND_GENERATOR, "");
						ClearPersonCommands(person);
						// Face Zero.
						npcface(person);
						// And speak.
						if(!Scenes.TalkToBlondeGirlAtrus)
						{
							talk("Oh, hello, Zero! Happy birthday! I have a present for you!","Blonde Girl");
							//*Recieve $10
							Scenes.TalkToBlondeGirlAtrus=true;
						}
						else
							talk("Hey! Don't get greedy!","Blonde Girl");
						// Reinstate NPC's movement.
						SetPersonScript(person, SCRIPT_COMMAND_GENERATOR, "_randomMove();");
						break;
					}
					case "pinkhairwoman_1":
					{
												
						// Face Zero.
						npcface(person);
						
						// Speak.
						talk("Happy birthday, Zero! \n I know it must be hard for you, not knowing who your parents are, but Aerion and Clair have done a fantastic job of raising you.","Zero's neighbor");
						
						break;
						
					}
					case "pinkhairgirl_1":
					{
						// Stop the NPC from moving around.
						SetPersonScript(person, SCRIPT_COMMAND_GENERATOR, "");
						ClearPersonCommands(person);
						
						// Face Zero.
						npcface(person);
						
						// And speak.
						if(choice("Zero! Zero! Can I see that thing in your hand?","little girl","Yes","No") == 0)
							talk("Oh wow! It's glowing a funny colour! I never saw it do that before!","little girl");
						else
							talk("Pleeeease, Zero!","little girl");
						SetPersonScript(person, SCRIPT_COMMAND_GENERATOR, "_randomMove();");
						break;
					}
					case "bluehair_1":
					{
						npcface(person);
						talk("I heard of a violent group. Apparently they took over the whole Northern Continent. But we don't have to worry - they couldn't possibly want to attack a tiny little village like this.","Guy");
						break;
					}
					case "warpToMapSouth1":
					{
						talk("Hey! I'm not permitting you to go back there! Especially not since you just got hurt!","Afaina");
						talk("Fine...","Zero");
					}
					case "warpToMapSouth2":
					{
						talk("Hey! I'm not permitting you to go back there! Especially not since you just got hurt!","Afaina");
						talk("Fine...","Zero");
					}
					case "warpToMapSouth3":
					{
						talk("Hey! I'm not permitting you to go back there! Especially not since you just got hurt!","Afaina");
						talk("Fine...","Zero");
					}
				}
				break;
			}
		}
		SetDelayScript(20,"g_TalkTriggered=false;");
	}
}